package Dnsproxy::Adblock;
use warnings;
use English '-no_match_vars';
use strict;
use Carp;

use Exporter qw(import);
use base qw(Exporter);
our @EXPORT_OK = qw(matchhost);

use vars qw($VERSION);
my %db;
#my %ipdb ;

$VERSION = '0.01';

# https://hosts.ubuntu101.co.za/domains.list
# https://github.com/mitchellkrogza/Ultimate.Hosts.Blacklist
# moad ( Mother of Ad-Block )
# https://adblock.mahakala.is/


sub initadblock {
my $args = shift;
%db = ();
#%ipdb = () ;
# read first blacklist , then whitelist
# print {*STDOUT} "$PROGRAM_NAME read black and whitelist files\n" or carp $ERRNO;
#print main::Dumper @ { $args->{'blacklist'} };
	if ( defined $args->{'blacklist'} ) {
		for my $f ( @ { $args->{'blacklist'} } ) {
		#print "read blacklistfile $f\n";
		_readfile ( $f ,'bl' );
		}
	}

if ( ( defined $args->{'whitelist'} ) and ( -e $args->{'whitelist'} ) ) {
	_readfile ( $args->{'whitelist'} ,'wi' );
}
return ;
}

sub _readfile {
my ( $file , $tag ) = @_;

open my $RO , '<' , $file or croak $ERRNO;
	while ( my $r = <$RO> ) {
   	chomp $r;
      if ( $r =~ /^\d{1,3}[.]\d{1,3}[.]\d{1,3}[.]\d{1,3}/smx ) { next ; }
		$db{$r} = $tag;
	}
#my $k = keys %db;

close $RO or carp $ERRNO;
return ;
}

sub matchhost {
my $hst = shift;
my @match;

if ( ( defined $db{$hst} ) and ( $db{$hst} eq 'bl' ) ) {
	push @match,$hst;
}

return \@match;

}
1;

