package Dnsproxy::Resolver;
use warnings;
use English '-no_match_vars';
use strict;
use Carp;
use Net::DNS::Resolver;
use Readonly ;
use vars qw($VERSION);
use Exporter qw(import);
use base qw(Exporter);
our @EXPORT_OK = qw(resolver);

$VERSION = '0.01';

my $resolve ;

Readonly my %LVL => ( DEBUG => 4 ,);


sub initresolver {
my $cfg = shift;

my $usevc;
my $dbg ;

if ( $cfg->{'log_level'} >= $LVL{'DEBUG'} ) {
	$dbg = '1' ;
}

if ( $cfg->{'proto'} eq 'tcp' ) {
	$usevc = '1';
}


$resolve = Net::DNS::Resolver->new(
            nameservers => \@ { $cfg->{'nameservers'} },
            searchlist  => \@ { $cfg->{'searchlist'} } ,
            usevc       => $usevc,
            debug       => $dbg,
				port => $cfg->{'port'},
);

         #tcp_timeout => $cfg->{'tcptimeout'},
         #udp_timeout => $cfg->{'udptimeout'},

        if (not defined $resolve ) {
            croak "$PROGRAM_NAME could not create resolver object\n";
        }

return;
}

sub resolver {

my ( $self,$qn,$qt ) = @_;

if ( not defined $qt ) {
	return $resolve->send ( $qn ) ;
}
return $resolve->send ( $qn, $qt ) ;
}

1;
__END__